

// -------------------------------------------------------------------- serve writing form
void handleHome() {
  Serial.println("Serve writing form");
  server.send(200, "text/html", wsHome);
}
// -------------------------------------------------------------------- find and replace parts of a string
String findAndReplace(String originalString, String findString, String replaceString) {
  String returnString = "";
  
  for (int i = 0; i < originalString.length() - findString.length(); i++) {
    String focusWindow = originalString.substring(i, i + findString.length());
    
    if (focusWindow == findString) {
      returnString += replaceString;
      i+=findString.length()-1;
    }else{
      returnString += originalString.substring(i, i+1);
    }
  }
  returnString += originalString.substring(originalString.length() - findString.length(),originalString.length());
  return returnString;
}

// -------------------------------------------------------------------- receive message, serve printing site
void handlePrint() {

  if (server.hasArg("plain") == false) {  //Check if body received
    server.send(200, "text/plain", "ERROR");
    return;
  }

  String message = server.arg("plain");   // get message

 // s.println("incoming message:");
 // s.println(message);
  //------------------------------------------------- find and replace (some) special characters
  message = message.substring(5,message.length())+"                              ";
  message = findAndReplace(message, "%0D%0A", "|"); /* new line */
  message = findAndReplace(message, "+", " ");      /* space    */
  message = findAndReplace(message, "%21", "!");
  message = findAndReplace(message, "%2C", ",");
  message = findAndReplace(message, "%3F", "?");
  message = findAndReplace(message, "%C3%A4", "ä");
  message = findAndReplace(message, "%C3%B6", "ö");
  message = findAndReplace(message, "%C3%BC", "ü");
  message = findAndReplace(message, "%C3%84", "Ä");
  message = findAndReplace(message, "%C3%96", "Ö");
  message = findAndReplace(message, "%C3%9C", "Ü");
  message = findAndReplace(message, "%E1%BA%9E", "{");//ß 
  message = findAndReplace(message, "%C3%9F", "{");//ß
  message = findAndReplace(message, "%27", "'");//' 
  message = findAndReplace(message, "%26", "&");//&
  message = findAndReplace(message, "%2B", "+");//+
  message = findAndReplace(message, "%3A", ":");//:
  message = findAndReplace(message, "%3B", ";");//;
  message = findAndReplace(message, "%22", "\"");//"
  message = findAndReplace(message, "%23", "#");//#
  message = findAndReplace(message, "%28", "(");//(
  message = findAndReplace(message, "%29", ")");//)
  message = findAndReplace(message, "%3D", "=");//=
  message = findAndReplace(message, "%40", "@");//@
  message = findAndReplace(message, "%2A", "*");//*
  message = findAndReplace(message, "%F0%9F%98%8A", "}");       //:) Smileys
  message = findAndReplace(message, "%E2%98%BA%EF%B8%8F", "}"); //:)
  message = findAndReplace(message, "%F0%9F%98%89", "}");       //:)
  message = findAndReplace(message, "%F0%9F%98%81", "~");       //:D open mouth Smileys
  message = findAndReplace(message, "%F0%9F%98%85", "~");       //:D
  message = findAndReplace(message, "%F0%9F%98%84", "~");       //:D
  message = findAndReplace(message, "%3C3", "$");               // heart
  message = findAndReplace(message, "%E2%9D%A4%EF%B8%8F", "$"); // heart
  message = findAndReplace(message, "%E2%99%A5%EF%B8%8F", "$"); // heart

  message = message.substring(0,message.length()-30);

  String cleanMessage = "";               // initialize clean up string
  //s.println("processed message:");
  s.println(message);                     // send cleaned up message via serial port to arduino mega
  server.send(200, "text/html", wsPrint);
}
